Attribute VB_Name = "General"
'actually returns an array of strings
Function Split(ByVal data As String, Optional delimiter As String = " ") As Variant

    Dim length As Integer
    Dim delimiterLength As Integer
    Dim index As Integer
    Dim nextIndex As Integer
    Dim datumCount As Integer
    Dim datum As String
    Dim datums() As String
    ReDim datums(1 To 100) As String 'set initial size
    
    
    'append a delimiter so we always catch the last datum without a special case
    'note that data is passed ByVal, so we are only changing a local copy
    data = data & delimiter
    length = Len(data)
    delimiterLength = Len(delimiter)
    index = 1
    datumCount = 0
    
    Do While (index < length)
        nextIndex = InStr(index, data, delimiter)
        If (IsNull(nextIndex)) Then Exit Do
        If (nextIndex = 0) Then Exit Do
        'this is the regular case
        If (nextIndex > index) Then
            'nextIndex=index when there is a sequence of single character delimiters
            datum = Mid$(data, index, nextIndex - index)
            If (Not (datum Like delimiter)) Then
                'this datum is something real, not just a delimiter
                datumCount = datumCount + 1
                datums(datumCount) = datum
            End If
        End If
        index = nextIndex + delimiterLength
    Loop
    
    'deal with case where there are no datums
    If datumCount = 0 Then
        Split = Null
    End If
    
    'Resize array just enough to hold arguments.
    ReDim Preserve datums(1 To datumCount) As String
    
    'return the array of datums
    Split = datums()
    

End Function


Public Sub SetComboBoxToItem(C As ComboBox, item As String)
    Dim X As Integer
    Dim listItem As String
    'item = item & "*"
    For X = 0 To C.ListCount
        listItem = C.List(X)
        'only match the first word of listItem
        'i.e., allow for tertiary words to be comments
        Dim spaceIndex As Integer
        spaceIndex = InStr(listItem, " ")
        If (spaceIndex > 0) Then
            listItem = Mid$(listItem, 1, spaceIndex - 1)
            'MsgBox "-" & listItem & "-"
        End If
        If (listItem Like item) Then
            C.listIndex = X
            Exit For
        End If
    Next X
End Sub




Public Sub InitializeKeyCodeComboBox(C As ComboBox)
    
    'special keys
    With C
        .AddItem "vbKeyLButton"
        .ItemData(0) = 1
        .AddItem "vbKeyRButton"
        .ItemData(1) = 2
        .AddItem "vbKeyCancel"
        .ItemData(2) = 3
        .AddItem "vbKeyMButton"
        .ItemData(3) = 4
        .AddItem "vbKeyBack"
        .ItemData(4) = 8
        .AddItem "vbKeyTab"
        .ItemData(5) = 9
        .AddItem "vbKeyClear"
        .ItemData(6) = 12
        .AddItem "vbKeyReturn"
        .ItemData(7) = 13
        .AddItem "vbKeyShift"
        .ItemData(8) = 16
        .AddItem "vbKeyControl"
        .ItemData(9) = 17
        .AddItem "vbKeyMenu (alt)"
        .ItemData(10) = 18
        .AddItem "vbKeyPause"
        .ItemData(11) = 19
        .AddItem "vbKeyCapital"
        .ItemData(12) = 20
        .AddItem "vbKeyEscape"
        .ItemData(13) = 27
        .AddItem "vbKeySpace"
        .ItemData(14) = 32
        .AddItem "vbKeyPageUp"
        .ItemData(15) = 33
        .AddItem "vbKeyPageDown"
        .ItemData(16) = 34
        .AddItem "vbKeyEnd"
        .ItemData(17) = 35
        .AddItem "vbKeyHome"
        .ItemData(18) = 36
        .AddItem "vbKeyLeft"
        .ItemData(19) = 37
        .AddItem "vbKeyUp"
        .ItemData(20) = 38
        .AddItem "vbKeyRight"
        .ItemData(21) = 39
        .AddItem "vbKeyDown"
        .ItemData(22) = 40
        .AddItem "vbKeySelect"
        .ItemData(23) = 41
        .AddItem "vbKeyPrint"
        .ItemData(24) = 42
        .AddItem "vbKeyExecute"
        .ItemData(25) = 43
        .AddItem "vbKeySnapshot"
        .ItemData(26) = 44
        .AddItem "vbKeyInsert"
        .ItemData(27) = 45
        .AddItem "vbKeyDelete"
        .ItemData(28) = 46
        .AddItem "vbKeyHelp"
        .ItemData(29) = 47
        .AddItem "vbKeyNumlock"
        .ItemData(30) = 144
    End With
    
    'regular alphabetic keys
    Dim k As Integer
    Dim ndx As Integer
    ndx = 31
    For k = 65 To 90
        With C
            .AddItem "vbKey" & Chr$(k)
            .ItemData(ndx) = k
        End With
        ndx = ndx + 1
    Next k
    
    'regular numeric keys
    For k = 48 To 57
        With C
            .AddItem "vbKey" & Chr$(k)
            .ItemData(ndx) = k
        End With
        ndx = ndx + 1
    Next k

    'numeric keypad: numerals
    For k = 96 To 105
        With C
            .AddItem "vbKeyNumpad" & (k - 96)
            .ItemData(ndx) = k
        End With
        ndx = ndx + 1
    Next k
    'numeric keypad: other keys
    With C
        .AddItem "vbKeyMultiply"
        .ItemData(ndx) = 106
        ndx = ndx + 1
        .AddItem "vbKeyAdd"
        .ItemData(ndx) = 107
        ndx = ndx + 1
        .AddItem "vbKeySeparator"
        .ItemData(ndx) = 108
        ndx = ndx + 1
        .AddItem "vbKeySubtract"
        .ItemData(ndx) = 109
        ndx = ndx + 1
        .AddItem "vbKeyDecimal"
        .ItemData(ndx) = 110
        ndx = ndx + 1
        .AddItem "vbKeyDivide"
        .ItemData(ndx) = 111
        ndx = ndx + 1
    End With
    
    'function keys
    For k = 112 To 127
        With C
            .AddItem "vbKeyF" & (k - 112)
            .ItemData(ndx) = k
        End With
        ndx = ndx + 1
    Next k
    
End Sub




