VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SignalHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public box As Shape
Public flag As Boolean
Public name As String
Public optEmulateKey As OptionButton
Public cboEmulateKey As ComboBox
Public optSendKeys As OptionButton
Public txtSendKeys As TextBox
Public optGenerateKeys As OptionButton
Public txtGenerateKeys As TextBox
Public generateKeys As Variant

Public cboKeyLookup As ComboBox


Public Sub test()
    MsgBox "this is a class"
End Sub


Public Sub ParseGenerateKeys()
    generateKeys = ParseGenerateKeysHelper(txtGenerateKeys.Text)
End Sub

'input is sort of a "disjunctive normal form"
'returns a two dimensional array
Private Function ParseGenerateKeysHelper(s As String) As Variant
    
    'get the disjuncts
    Dim disjuncts As Variant
    disjuncts = Split(s, ",")
    
    If IsNull(disjuncts) Then
        ParseGenerateKeysHelper = Null
        Exit Function
    End If
    
    Dim codes As Variant
    ReDim codes(LBound(disjuncts) To UBound(disjuncts), 0 To 9)
    
    'parse each individual disjunct
    Dim i As Integer
    For i = LBound(disjuncts) To UBound(disjuncts)
        
        Dim conjuncts As Variant
        conjuncts = Split(disjuncts(i), "+")
        
        If IsNull(conjuncts) Then
            ParseGenerateKeysHelper = Null
            Exit Function
        End If
        
        'record the number of conjuncts in this disjunct
        codes(i, 0) = 1 + UBound(conjuncts) - LBound(conjuncts)
        
        Dim j As Integer
        Dim k As Integer 'loop dependent
        k = 1
        For j = LBound(conjuncts) To UBound(conjuncts)
            SetComboBoxToItem cboKeyLookup, (conjuncts(j))
            Dim listIndex As Integer
            listIndex = cboKeyLookup.listIndex
            
            If listIndex < 0 Then
                codes(i, k) = listIndex
            Else
                codes(i, k) = cboKeyLookup.ItemData(listIndex)
            End If
            
            k = k + 1
        Next j
    
        'oh, this language is so lame ...
        'Dim conjunctCodesVariant As Variant
        'conjunctCodesVariant = conjunctCodes
        'disjuncts(i) = conjunctCodesVariant
        
    Next i
    
    ParseGenerateKeysHelper = codes
    
End Function



'basically a unit test
Public Function GenerateKeyCodeString() As String
    
    Dim result As String
    
    If IsNull(generateKeys) Then
        GenerateKeyCodeString = ""
        Exit Function
    End If
    
    Dim i As Integer
    For i = LBound(generateKeys, 1) To UBound(generateKeys, 1)
        
        Dim conjunctCount As Integer
        conjunctCount = generateKeys(i, 0)
        
        Dim j As Integer
        For j = 1 To conjunctCount
            result = result & generateKeys(i, j) & "+"
        Next j
        
        result = result & ","
        
    Next i

    GenerateKeyCodeString = result
    
End Function



Public Sub SignalOn()
    
    box.FillColor = BRIGHT
    flag = True
    
    If optEmulateKey Then
        Dim emKey As Integer
        emKey = cboEmulateKey.ItemData(cboEmulateKey.listIndex)
        'LogEvent name & " On: emulate genKey  " & genKey
        PressKey emKey  'VK_SHIFT
    
    ElseIf optSendKeys Then
        'LogEvent name & " On: send keys  " & txtSendKeys.Text
        SendKeys txtSendKeys.Text

    ElseIf optGenerateKeys Then
    
        If IsNull(generateKeys) Then Exit Sub
                
        Dim i As Integer, j As Integer
        Dim genKey As Integer
        For i = LBound(generateKeys, 1) To UBound(generateKeys, 1)
            
            Dim conjunctCount As Integer
            conjunctCount = generateKeys(i, 0)
            
            'press all the conjuncts of this disjunct
            For j = 1 To conjunctCount
                genKey = generateKeys(i, j)
                If genKey > 0 Then PressKey genKey
            Next j
            
            'release all the conjuncts of this disjunct
            'note this is the reverse order of pressing
            For j = conjunctCount To 1 Step -1
                genKey = generateKeys(i, j)
                If genKey > 0 Then ReleaseKey genKey
            Next j
            
        Next i
    
    End If

End Sub


Public Sub SignalOff()
    
    box.FillColor = DARK
    flag = False
    
    If optEmulateKey Then
        Dim key As Integer
        key = cboEmulateKey.ItemData(cboEmulateKey.listIndex)
        'LogEvent name & " Off: emulate key  " & key
        ReleaseKey key  'VK_SHIFT
    
    ElseIf optSendKeys Then
        'do nothing:  all the action is on the downstroke
        'LogEvent name & " Off: send keys"
        
    ElseIf optGenerateKeys Then
        'do nothing:  all the action is on the downstroke
        
    End If
    
End Sub


